# coding: utf-8

"""
    Humanloop API

    The Humanloop API allows you to interact with Humanloop from your product or service.  You can do this through HTTP requests from any language or via our official Python or TypeScript SDK.  To install the official [Python SDK](https://pypi.org/project/humanloop/), run the following command:  ```bash pip install humanloop ```  To install the official [TypeScript SDK](https://www.npmjs.com/package/humanloop), run the following command:  ```bash npm i humanloop ```  ---  Guides and further details about key concepts can be found in [our docs](https://docs.humanloop.com/).

    The version of the OpenAPI document: 4.0.0
    Generated by: https://konfigthis.com
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from humanloop import schemas  # noqa: F401


class ToolConfigResponse(
    schemas.DictSchema
):
    """
    This class is auto generated by Konfig (https://konfigthis.com)
    """


    class MetaOapg:
        required = {
            "signature",
            "name",
            "description",
            "is_preset",
            "id",
            "type",
        }
        
        class properties:
            description = schemas.StrSchema
            id = schemas.StrSchema
            
            
            class type(
                schemas.EnumBase,
                schemas.StrSchema
            ):
                
                @schemas.classproperty
                def TOOL(cls):
                    return cls("tool")
            name = schemas.StrSchema
            signature = schemas.StrSchema
            is_preset = schemas.BoolSchema
            other = schemas.DictSchema
            source = schemas.StrSchema
            setup_schema = schemas.DictSchema
            parameter_schema = schemas.DictSchema
            preset_name = schemas.StrSchema
            __annotations__ = {
                "description": description,
                "id": id,
                "type": type,
                "name": name,
                "signature": signature,
                "is_preset": is_preset,
                "other": other,
                "source": source,
                "setup_schema": setup_schema,
                "parameter_schema": parameter_schema,
                "preset_name": preset_name,
            }
    
    signature: MetaOapg.properties.signature
    name: MetaOapg.properties.name
    description: MetaOapg.properties.description
    is_preset: MetaOapg.properties.is_preset
    id: MetaOapg.properties.id
    type: MetaOapg.properties.type
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["description"]) -> MetaOapg.properties.description: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["id"]) -> MetaOapg.properties.id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["type"]) -> MetaOapg.properties.type: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["name"]) -> MetaOapg.properties.name: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["signature"]) -> MetaOapg.properties.signature: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["is_preset"]) -> MetaOapg.properties.is_preset: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["other"]) -> MetaOapg.properties.other: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["source"]) -> MetaOapg.properties.source: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["setup_schema"]) -> MetaOapg.properties.setup_schema: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["parameter_schema"]) -> MetaOapg.properties.parameter_schema: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["preset_name"]) -> MetaOapg.properties.preset_name: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["description", "id", "type", "name", "signature", "is_preset", "other", "source", "setup_schema", "parameter_schema", "preset_name", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["description"]) -> MetaOapg.properties.description: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["id"]) -> MetaOapg.properties.id: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["type"]) -> MetaOapg.properties.type: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["name"]) -> MetaOapg.properties.name: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["signature"]) -> MetaOapg.properties.signature: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["is_preset"]) -> MetaOapg.properties.is_preset: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["other"]) -> typing.Union[MetaOapg.properties.other, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["source"]) -> typing.Union[MetaOapg.properties.source, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["setup_schema"]) -> typing.Union[MetaOapg.properties.setup_schema, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["parameter_schema"]) -> typing.Union[MetaOapg.properties.parameter_schema, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["preset_name"]) -> typing.Union[MetaOapg.properties.preset_name, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["description", "id", "type", "name", "signature", "is_preset", "other", "source", "setup_schema", "parameter_schema", "preset_name", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *args: typing.Union[dict, frozendict.frozendict, ],
        signature: typing.Union[MetaOapg.properties.signature, str, ],
        name: typing.Union[MetaOapg.properties.name, str, ],
        description: typing.Union[MetaOapg.properties.description, str, ],
        is_preset: typing.Union[MetaOapg.properties.is_preset, bool, ],
        id: typing.Union[MetaOapg.properties.id, str, ],
        type: typing.Union[MetaOapg.properties.type, str, ],
        other: typing.Union[MetaOapg.properties.other, dict, frozendict.frozendict, schemas.Unset] = schemas.unset,
        source: typing.Union[MetaOapg.properties.source, str, schemas.Unset] = schemas.unset,
        setup_schema: typing.Union[MetaOapg.properties.setup_schema, dict, frozendict.frozendict, schemas.Unset] = schemas.unset,
        parameter_schema: typing.Union[MetaOapg.properties.parameter_schema, dict, frozendict.frozendict, schemas.Unset] = schemas.unset,
        preset_name: typing.Union[MetaOapg.properties.preset_name, str, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'ToolConfigResponse':
        return super().__new__(
            cls,
            *args,
            signature=signature,
            name=name,
            description=description,
            is_preset=is_preset,
            id=id,
            type=type,
            other=other,
            source=source,
            setup_schema=setup_schema,
            parameter_schema=parameter_schema,
            preset_name=preset_name,
            _configuration=_configuration,
            **kwargs,
        )
